<template>
  <VApp
    v-if="!loading"
    :dark="dark"
  >
    <VToolbar
      color="brown darken-1"
      dark
      flat
    >
      <VBtn
        color="primary"
        @click="toggleModal"
      >
        Novo Item
      </VBtn>

      <VSpacer />
      <VTooltip bottom>
        <template v-slot:activator="{ on }">
          <VBtn
            large
            icon
            @click="dark = !dark"
            v-on="on"
          >
            <VIcon>invert_colors</VIcon>
          </VBtn>
        </template>
        <span>Inverter a cor</span>
      </VTooltip>

      <VDivider
        class="mx-2"
        inset
        vertical
      />

      <VTooltip bottom>
        <template v-slot:activator="{ on }">
          <VBtn
            large
            icon
            href="//gitlab.com/i.leonardo/ativ-nuxt-crud-api-fake"
            target="_blank"
            v-on="on"
          >
            <img
              src="@/assets/github/logo-light.png"
              width="24px"
            >
          </VBtn>
        </template>
        <span>GitHub</span>
      </VTooltip>
    </VToolbar>

    <VContent>
      <Nuxt />
    </VContent>

    <VFooter
      color="transparent"
      class="px-3"
    >
      Copyright © 2019 Leonardo C. Carvalho
      <VSpacer />
      Feito com muito amor&nbsp;<VIcon color="red">
        favorite
      </VIcon>
    </VFooter>

    <!-- message -->
    <VSnackbar
      v-model="snackbar"
      :color="msg.color"
      bottom
      multi-line
    >
      {{ msg.message }}
      <VBtn
        flat
        @click="snackbar = false"
      >
        Fechar
      </VBtn>
    </VSnackbar>
  </VApp>
</template>

<script lang="ts">
import {
  Component, Vue, State, Mutation,
} from 'nuxt-property-decorator';

@Component
export default class Default extends Vue {
  @State
  msg!: {
    bool: boolean
  }

  @Mutation
  setBoolMsg!: (bool: boolean) => void

  @Mutation
  toggleModal!: void

  loading = true

  dark = false

  get snackbar() {
    return this.msg.bool;
  }

  set snackbar(bool: boolean) {
    this.setBoolMsg(bool);
  }

  async mounted() {
    await this.$nextTick();

    this.$nuxt.$loading.start();

    setTimeout(() => {
      this.$nuxt.$loading.finish();
      this.loading = false;
    }, 500);
  }
}
</script>
